#include "BootLoader/boot_loader.hpp"
#include <PSX/System/IOPorts/dMa_io.hpp>
#include <stdio.h>

namespace Setup {
    static void enable_DMA() {
        DMA::DPCR.write(DMA::DPCR.read() | DMA::DMAControlRegister::SPUEnable | DMA::DMAControlRegister::GPUEnable);
    }

    JabyEngine::NextRoutine start() {
        enable_DMA();

        SPU::stop_voices();

        GPU::setup();
        GPU::display_logo();
        //Pause??

        SPU::setup();
        return BootFile::setup();
    }
}